<template>
  <LineChart
    style="height:250px;"
    :chart-data="dataCollection"
    :options="options"
    :height="null"
    :width="null"
  />
</template>

<script>
import LineChart from './LineChart'
export default {
  name: 'WinLossChart',
  components: {
    LineChart
  },
  props: {
    history: {
      required: true,
      type: Array
    }
  },
  data () {
    return {
      dataCollection: {},
      options: {
        responsive: true,
        maintainAspectRatio: false,
        aspectRatio: 2,
        title: {
          display: true,
          text: this.$t('player.win_loss_chart_title')
        },
        scales: {
          xAxes: [{
            stacked: false,
            gridLines: {
              color: '#282828'
            }
          }],
          yAxes: [
            {
              id: 'coop-axis',
              position: 'right',
              stacked: false,
              gridLines: {
                color: '#282828'
              },
              scaleLabel: {
                display: true,
                labelString: 'CooP'
              }
            }, {
              id: 'pvp-axis',
              position: 'left',
              stacked: false,
              scaleLabel: {
                display: true,
                labelString: 'PvP'
              }
            }
          ]
        }
      }
    }
  },
  computed: {
    pvpBattles () {
      if (!this.history[0].pvp) {
        return []
      }
      const arr = this.history.map((history) => {
        const pvp = history.pvp
        return (pvp.gameWin * 100 / pvp.gamePlayed).toFixed(2)
      })
      return arr
    },
    coopBattles () {
      if (!this.history[0].coop) {
        return []
      }
      const arr = this.history.map((history) => {
        const coop = history.coop
        return (coop.gameWin * 100 / coop.gamePlayed).toFixed(2)
      })
      return arr
    },
    days () {
      const arr = this.history.map((history) => {
        const date = new Date(history.createdAt)
        const arr = date.toUTCString().split(' ')
        return arr[1] + ' ' + arr[2]
      })
      return arr
    }
  },
  mounted () {
    this.dataCollection = {
      labels: this.days,
      datasets: [
        {
          yAxisID: 'pvp-axis',
          label: this.$t('pvp.pvp') + '%',
          borderColor: 'red',
          data: this.pvpBattles
        },
        {
          yAxisID: 'coop-axis',
          label: this.$t('coop.coop') + '%',
          borderColor: 'blue',
          data: this.coopBattles
        }
      ]
    }
  }
}
</script>
